library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_unsigned.ALL;
entity DAC is 
--	TI TLV5919 DAC
	port(
		clk_in 	: 	in STD_LOGIC;
		dac_in	:	in STD_LOGIC_VECTOR(11 downto 0);
		cs			:	out STD_LOGIC;	-- Chip select signal 
		ldac		:	out STD_LOGIC;	-- Load DAC 
		pd			:	out STD_LOGIC; -- low power mode 
		we			:	out STD_LOGIC;	-- write enable
		dac_out	:	out STD_LOGIC_VECTOR(11 downto 0)
		);
end DAC;

architecture DAC of DAC is
begin
	process(clk_in)
	begin
	if rising_edge(clk_in) then
		dac_out <= dac_in;
	end if;
	end process;	
we 		<= clk_in; 	-- transparant output of clk to we
cs 		<= '0'; 		-- chip always selected
ldac 		<= '0'; 		-- double buffer not used
pd 		<= '1';		-- high power mode
end DAC;

